varying mediump vec4 var_position;
varying mediump vec3 var_normal;
varying mediump vec2 var_texcoord0;
varying mediump float var_dist;

uniform lowp sampler2D tex0;
uniform lowp vec4 tint;

const lowp vec4 light_color = vec4(1.0, 0.98, 0.9, 0.15);
const lowp vec4 shadow_color = vec4(0.0, 0.05, 0.10, 0.25);
const lowp vec3 light_vec = normalize(vec3(0.3, 0.1, 1.0));

void main() {
    // Pre-multiply alpha since all runtime textures already are
    vec4 tint_pm = vec4(tint.xyz * tint.w, tint.w);
    vec4 color = texture2D(tex0, var_texcoord0.xy) * tint_pm;

	float light = dot(var_normal, light_vec);
	if(light >= 0.5) {
		light = (light - 0.5)*2.0;
		color.rgb = mix(color.rgb, color.rgb + light_color.rgb, light * light_color.w);
	}
	else {
		light = (1.0 - light*2.0);
		color.rgb = mix(color.rgb, color.rgb * shadow_color.rgb, light * shadow_color.w);
	}
	color.rgb = mix(color.rgb, vec3(0.0, 0.0, 0.0), min(0.8, var_dist*0.0025));
    gl_FragColor = color;
}

